import java.util.*;
import java.io.*;

import static java.lang.Math.*;

public class Main {

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        pw = new PrintWriter(System.out);
        int t = nextInt();
        int n = nextInt();
        Triangle_ugol[] b = new Triangle_ugol[n];
        for (int i = 0; i < n; i++) {
            b[i] = new Triangle_ugol(nextInt(), nextInt(), nextInt(), nextInt(), nextInt(), nextInt());
        }
        Triangle_storona2[] a = new Triangle_storona2[n];
        for (int i = 0; i < n; i++) {
            a[i] = new Triangle_storona2(pif(b[i].x1, b[i].y1, b[i].x2, b[i].y2),
                    pif(b[i].x2, b[i].y2, b[i].x3, b[i].y3),
                    pif(b[i].x1, b[i].y1, b[i].x3, b[i].y3));
        }
        ArrayList<Answer> ans = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                for (int k = j + 1; k < n; k++) {
                    for (int l = k + 1; l < n; l++) {
                        if (check(a[i], a[j], a[k], a[l])) {
                            ans.add(new Answer(i + 1, j + 1, k + 1, l + 1));
                        }
                    }
                }
            }
        }
        pw.println(ans.size());
        for (Answer answer : ans) {
            pw.println(answer.i1 + " " + answer.i2 + " " + answer.i3 + " " + answer.i4);
        }
        pw.close();
        pw.println(((n * (n - 1) * (n - 2) * (n - 3)) / 24));
    }

    static BufferedReader br;
    static PrintWriter pw;
    static StringTokenizer st = new StringTokenizer("");
    static long mod = 1_000_000_000;

    static long pif(long x1, long y1, long x2, long y2) {
        return abs(x1 - x2) * abs(x1 - x2) + abs(y1 - y2) * abs(y1 - y2);
    }

    static boolean check(Triangle_storona2 t1, Triangle_storona2 t2, Triangle_storona2 t3, Triangle_storona2 t4) {
        long[] a1 = {t1.a1, t1.a2, t1.a3};
        long[] a2 = {t2.a1, t2.a2, t2.a3};
        long[] a3 = {t3.a1, t3.a2, t3.a3};
        long[] a4 = {t4.a1, t4.a2, t4.a3};
        if (inside(a1, a2, a3, a4)) return true;
        if (inside(a2, a1, a3, a4)) return true;
        if (inside(a3, a1, a2, a4)) return true;
        return inside(a4, a1, a2, a3);
    }

    static boolean inside(long[] a1, long[] a2, long[] a3, long[] a4) {
        long[][] m = {a2, a3, a4};
        for (int i = 0; i < 3; i++) {
            for (int j = 0; j < 3; j++) {
                if (a1[0] == m[i][j]) {
                    long f1, f2;
                    if (j == 0) {
                        f1 = m[i][1];
                        f2 = m[i][2];
                    } else if (j == 1) {
                        f1 = m[i][0];
                        f2 = m[i][2];
                    } else {
                        f1 = m[i][0];
                        f2 = m[i][1];
                    }
                    for (int k = 0; k < 3; k++) {
                        if (k != i) {
                            for (int l = 0; l < 3; l++) {
                                if (a1[1] == m[k][l]) {
                                    long s1, s2;
                                    if (l == 0) {
                                        s1 = m[k][1];
                                        s2 = m[k][2];
                                    } else if (l == 1) {
                                        s1 = m[k][0];
                                        s2 = m[k][2];
                                    } else {
                                        s1 = m[k][0];
                                        s2 = m[k][1];
                                    }
                                    for (int n = 0; n < 3; n++) {
                                        if (a1[2] == m[3 - i - k][n]) {
                                            long t1, t2;
                                            if (n == 0) {
                                                t1 = m[3 - i - k][1];
                                                t2 = m[3 - i - k][2];
                                            } else if (n == 1) {
                                                t1 = m[3 - i - k][0];
                                                t2 = m[3 - i - k][2];
                                            } else {
                                                t1 = m[3 - i - k][0];
                                                t2 = m[3 - i - k][1];
                                            }
                                            if ((ugol_check(a1[0], a1[1], a1[2], f1, f2, s1, s2) || ugol_check(a1[0], a1[1], a1[2], f2, f1, s1, s2) || ugol_check(a1[0], a1[1], a1[2], f1, f2, s2, s1) || ugol_check(a1[0], a1[1], a1[2], f2, f1, s2, s1)) &&
                                                    (ugol_check(a1[1], a1[2], a1[0], s1, s2, t1, t2) || ugol_check(a1[1], a1[2], a1[0], s2, s1, t1, t2) || ugol_check(a1[1], a1[2], a1[0], s1, s2, t2, t1) || ugol_check(a1[1], a1[2], a1[0], s2, s1, t2, t1)) &&
                                                    (ugol_check(a1[0], a1[2], a1[1], f1, f2, t1, t2) || ugol_check(a1[0], a1[2], a1[1], f2, f1, t1, t2) || ugol_check(a1[0], a1[2], a1[1], f1, f2, t2, t1) || ugol_check(a1[0], a1[2], a1[1], f2, f1, t2, t1))) {
                                                return true;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        return false;
    }

    static boolean ugol_check(long ins1, long ins2, long ins3, long a1, long a2, long b1, long b2) {
        double cos_ins = (double) (ins1 + ins2 - ins3) / (2 * sqrt(ins1 * ins2));
        double cos_a = (double) (ins1 + a1 - a2) / (2 * sqrt(ins1 * a1));
        double cos_b = (double) (ins2 + b1 - b2) / (2 * sqrt(ins2 * b1));
        return cos(acos(cos_ins) + acos(cos_a) + acos(cos_b)) == -1;
    }


    public static boolean hasNext() throws IOException {
        if (st.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            st = new StringTokenizer(s);
            if (st.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}

class Triangle_ugol {
    int x1;
    int y1;
    int x2;
    int y2;
    int x3;
    int y3;

    public Triangle_ugol(int x1, int y1, int x2, int y2, int x3, int y3) {
        this.x1 = x1;
        this.y1 = y1;
        this.x2 = x2;
        this.y2 = y2;
        this.x3 = x3;
        this.y3 = y3;
    }
}

class Triangle_storona2 {
    long a1, a2, a3;

    public Triangle_storona2(long a1, long a2, long a3) {
        this.a1 = a1;
        this.a2 = a2;
        this.a3 = a3;
    }
}

class Answer {
    int i1, i2, i3, i4;

    public Answer(int i1, int i2, int i3, int i4) {
        this.i1 = i1;
        this.i2 = i2;
        this.i3 = i3;
        this.i4 = i4;
    }
}
