import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class Main {

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        pw = new PrintWriter(System.out);
        int n = nextInt();
        int k = nextInt();
        g = new ArrayList[n];
        for (int i = 0; i < n; i++) {
            g[i] = new ArrayList<>();
        }
        for (int i = 0; i < n - 1; i++) {
            int x = nextInt() - 1;
            g[x].add(i + 1);
            g[i + 1].add(x);
        }
        col = new int[n];
        used = new boolean[n];
        dfs(0, -1);
        int c0 = 0;
        int c1 = 0;
        for (int i = 0; i < n; i++) {
            if (col[i] == 1) c1++;
            else c0++;
        }
        pw.println(min(c0, c1) + " " + 0);
        pw.close();
    }


    static BufferedReader br;
    static PrintWriter pw;
    static StringTokenizer st = new StringTokenizer("");

    static ArrayList<Integer>[] g;
    static int[] col;
    static boolean[] used;

    static void dfs(int v, int p) {
        used[v] = true;
        if (p != -1) {
            col[v] = 1 - col[p];
        }
        for (int to : g[v]) {
            if (!used[to]) {
                dfs(to, v);
            }
        }
    }

    static long gcd(long a, long b) {
        while (b != 0) {
            a %= b;
            long h = a;
            a = b;
            b = h;
        }
        return a;
    }

    public static boolean hasNext() throws IOException {
        if (st.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            st = new StringTokenizer(s);
            if (st.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}

class Pair {
    long val;
    int ind;

    public Pair(long val, int ind) {
        this.val = val;
        this.ind = ind;
    }
}

class Drob {
    long a, b;

    public Drob(long a, long b) {
        this.a = a;
        this.b = b;
    }
}

class DrobComp implements Comparator<Drob> {

    @Override
    public int compare(Drob o1, Drob o2) {
        return Long.compare(o1.a * o2.b, o2.a * o1.b);
    }
}